[Setup]
;-- Main Setup Information
 AppName=448Delta Encryption
 AppVerName=448Delta 3.5A
 AppCopyright=Copyright  1995-2002 NetWorkDLS, Inc.
 DefaultDirName={pf}\448Delta Encryption
 DefaultGroupName=448Delta
 UninstallDisplayIcon={app}\448Delta.Exe
 UninstallStyle = modern
 WizardSmallImageFile=Resources\448Logo.Bmp
 WizardImageFile=Resources\NetSetup.Bmp
 AppMutex=448Delta Encryption
 AdminPrivilegesRequired=Yes
 MinVersion=4.0.1381,4.1
 Uninstallable=Yes
 LicenseFile=Resources\EULA.txt
 compression=ZIP/9

;-- Windows 2000 & XP (Support Dialog)
 AppPublisher=NetWorkDLS
 AppPublisherURL=http://www.NetWorkDLS.com/
 AppUpdatesURL=http://www.NetWorkDLS.com/
 AppVersion=3.5A

[Types]
 Name: "Full"; Description: "Full installation"
 Name: "Compact"; Description: "Compact installation"
 Name: "Custom"; Description: "Custom installation"; Flags: iscustom

[Components]
 Name: "Main"; Description: "Main Files";     Types: Full Compact Custom; Flags: fixed;
 Name: "DLL";  Description: "448Delta DLL's"; Types: Full Compact Custom; Flags: fixed;
 Name: "Help"; Description: "Help File";      Types: Full Custom;
 Name: "SelfExe"; Description: "Self Extract Support";    Types: Full;
 Name: "Command"; Description: "Command Prompt Support";  Types: Full;
 Name: "Thread";  Description: "Advanced Threading Support"; Types: Full;
 Name: "Tracking"; Description: "Use Tracking Support";   Types: Full;

[UninstallRun]
 Filename: "{app}\RegFix.Exe"; Parameters: "Uninstall"

[Files]
 Source: "..\448Delta.Exe";               DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "Resources\EULA.txt";            DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "RegFix\RegFix.Exe";             DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "Register\Register.Exe";         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "Libraries\Registry.Dll";        DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: DLL
 Source: "Libraries\Windows.Dll";         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: DLL
 Source: "Libraries\BlowFish.Dll";        DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: DLL
 Source: "Help\448Delta.Chm";             DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Help
 Source: "448Cmd\448Cmd.Exe";             DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Command
 Source: "SelfAppend\SelfAppend.Exe";     DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: SelfExe
 Source: "Self-Extract\Self-Extract.Exe"; DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: SelfExe
 Source: "448Query\448Query.Exe";         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Tracking
 Source: "448Priority\448Priority.Exe";   DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Thread

[Icons]
 Name: "{group}\Register 448Delta";  Filename: "{app}\Register.Exe";    Components: Main
 Name: "{group}\448Delta Help";      Filename: "{app}\448Delta.Chm";    Components: Help
 Name: "{group}\448Delta Query";     Filename: "{app}\448Query.Exe";    Components: Tracking
 Name: "{group}\Set Priority";       Filename: "{app}\448Priority.Exe"; Components: Thread
 Name: "{group}\Uninstall";          Filename: "{app}\Unins000.Exe"; Components: Thread

[Registry]
;-- Create 448Delta "ALL FILES" Encryption Shell Extention
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption"; ValueType: string;  ValueData: "Open With 448&Delta"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\Command"; ValueType: string;  ValueData: """{app}\448Delta.Exe"" %1"

;-- Create 448Delta "Folder" Encryption Shell Extention
 Root: HKCR; Subkey: "Directory\shell\Encrypt Folder"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "Directory\shell\Encrypt Folder"; ValueType: string;  ValueData: "Open With 448&Delta"
 Root: HKCR; Subkey: "Directory\shell\Encrypt Folder\command"; ValueType: string;  ValueData: """{app}\448Delta.Exe"" %1"

;-- Create 448Delta "Single File" Association
 Root: HKCR; Subkey: ".448"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: ".448"; ValueType: string;  ValueData: "448File"
 Root: HKCR; Subkey: "448File"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File"; ValueType: string;  ValueName: "NeverShowExt"; ValueData:""
 Root: HKCR; Subkey: "448File"; ValueType: string;  ValueData:"448Delta Encrypted File"
 Root: HKCR; Subkey: "448File\Shell\Open\Command"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File\Shell\Open\Command"; ValueType: string;  ValueData:"""{app}\448Delta.Exe"" %1"
 Root: HKCR; Subkey: "448File\DefaultIcon"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File\DefaultIcon"; ValueType: string;  ValueData:"{app}\448Delta.Exe,2"

 Root: HKCR; Subkey: "448File\Shell\CreateSelf"; ValueType: string;  ValueData: "Create Self Extractor"; Components: SelfExe
 Root: HKCR; Subkey: "448File\Shell\CreateSelf\Command"; Flags: uninsdeletekey noerror; Components: SelfExe
 Root: HKCR; Subkey: "448File\Shell\CreateSelf\Command"; ValueType: string;  ValueData:"""{app}\SelfAppend.Exe"" %1"; Components: SelfExe

;-- Create 448Delta "Package File" Association
 Root: HKCR; Subkey: ".448Pkg"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: ".448Pkg"; ValueType: string;  ValueData: "448PkgFile"
 Root: HKCR; Subkey: "448PkgFile"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile"; ValueType: string;  ValueName: "NeverShowExt"; ValueData:""
 Root: HKCR; Subkey: "448PkgFile"; ValueType: string;  ValueData:"448Delta Encrypted Package"
 Root: HKCR; Subkey: "448PkgFile\Shell\Open\Command"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile\Shell\Open\Command"; ValueType: string;  ValueData:"""{app}\448Delta.Exe"" %1"
 Root: HKCR; Subkey: "448PkgFile\DefaultIcon"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile\DefaultIcon"; ValueType: string;  ValueData:"{app}\448Delta.Exe,1"

 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf"; ValueType: string;  ValueData: "Create Self Extractor"; Components: SelfExe
 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf\Command"; Flags: uninsdeletekey noerror; Components: SelfExe
 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf\Command"; ValueType: string;  ValueData:"""{app}\SelfAppend.Exe"" %1"; Components: SelfExe

;-- Create 448Delta Encryption "New File" Shell Extention
; Root: HKCR; Subkey: ".448\ShellNew"; Flags: uninsdeletekey noerror;
; Root: HKCR; Subkey: ".448\ShellNew"; ValueType: string;  ValueName: "NullFile"; ValueData:""

;-- Delete Old "Open With" Key
 Root: HKCR; Subkey: "Unknown\shell\openas\command"; Flags: deletekey;
 Root: HKCR; Subkey: "Unknown\shell\openas"; Flags: deletekey;

;-- Create New "Open With" Key
 Root: HKCR; Subkey: "*\Shell\openas\command";
 Root: HKCR; Subkey: "*\Shell\openas\command"; ValueType: string;  ValueData: "rundll32.exe shell32.dll,OpenAs_RunDLL %1"

;-- Set "Open With" Key To Default
 Root: HKCR; Subkey: "*\Shell"; ValueType: string;  ValueData: "openas"
 
;-- Create Path Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path";
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "Path";       ValueData:"{app}"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "SelfExtract"; ValueData:"{app}\Self-Extract.Exe"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "SelfAppend"; ValueData:"{app}\SelfAppend.Exe"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "Executable"; ValueData:"{app}\448Delta.Exe"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "HelpPath";   ValueData:"{app}\448Delta.Chm"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Path"; ValueType: string;  ValueName: "RegisterData";   ValueData:"{app}\Register.Dat"

;-- Create Dialog Information Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\PasswordDialog"; ValueType: dword;  ValueName: "TopMost"; ValueData:1
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\StatusDialog";   ValueType: dword;  ValueName: "TopMost"; ValueData:1

;-- Create Last Use Information Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\LastRun"; ValueType: string;  ValueName: "User"; ValueData:"N/A"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\LastRun"; ValueType: string;  ValueName: "Time"; ValueData:"N/A"
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\LastRun"; ValueType: string;  ValueName: "Date"; ValueData:"N/A"

;-- Create Misc Settings Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Settings"; ValueType: dword;  ValueName: "UseCompression"; ValueData:0
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Settings"; ValueType: dword;  ValueName: "DeleteSource"; ValueData:0

;-- Create Version Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Version"; ValueType: string;  ValueName: "ShortVersion"; ValueData:3.5A
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Version"; ValueType: string;  ValueName: "LongVersion"; ValueData:3.5 - Revision A

;-- Create Registration Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry";
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; Flags: createvalueifdoesntexist; ValueType: dword;  ValueName: "448Code";    ValueData:0
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; Flags: createvalueifdoesntexist; ValueType: dword;  ValueName: "448Reg1";    ValueData:0
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; Flags: createvalueifdoesntexist; ValueType: dword;  ValueName: "448Reg2";    ValueData:0
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; Flags: createvalueifdoesntexist; ValueType: dword;  ValueName: "448Reg3";    ValueData:0
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; Flags: createvalueifdoesntexist; ValueType: dword;  ValueName: "Registered"; ValueData:0
 
;-- Create Priority Keys For Use Within 448Delta
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Priority"; ValueType: dword;  ValueName: "ProcessBoost"; ValueData:1
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Priority"; ValueType: dword;  ValueName: "ThreadBoost";  ValueData:1
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Priority"; ValueType: dword;  ValueName: "Process";      ValueData:2
 Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Priority"; ValueType: dword;  ValueName: "Thread";       ValueData:4

;-- Create Registration Keys For Use Within 448Delta (If Registered)
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry";
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; ValueType: dword;  ValueName: "448Code";    ValueData:125874912
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; ValueType: dword;  ValueName: "448Reg1";    ValueData:126195
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; ValueType: dword;  ValueName: "448Reg2";    ValueData:122348
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; ValueType: dword;  ValueName: "448Reg3";    ValueData:110162
; Root: HKCR; Subkey: "*\Shell\448Delta_Encryption\AppInfo\Registry"; ValueType: dword;  ValueName: "Registered"; ValueData:1

